import 'package:objd/basic/block.dart';
import 'dart:convert';
class Item {
  ItemType type;
  int count;
  int slot;
  Map<String,dynamic> tag = {};
  Item(dynamic type,{this.count,this.slot,int damage, int model, Map<String,dynamic> nbt}){
    // check item type
    if(type is ItemType ) this.type = type;
    else if(type is Block ) this.type = new ItemType(type.toString());
    else if(type is String ) this.type = new ItemType(type);
    else throw("Please insert either an ItemType, a Block or a string representing a item type into Item");

    // check tags
    if(nbt != null && nbt.length > 0) tag.addAll(nbt);
    if(damage != null) tag["Damage"] = damage;
    if(model != null) tag["CustomModelData"] = model;
  }
  String getGiveNotation(){
    String result = type.toString();
    if(tag != null && tag.length > 0){
      result += json.encode(tag);
    }
    result += " ";
    if(count != null) result += count.toString();
    return result;
  }
  Map<String,dynamic> getMap(){
    return {"id":type.toString(), "tag":tag, "Count":count,"Slot":slot};
  }
  String getNbt(){
    return json.encode(this.getMap());
  }
}

class ItemType {
  String _type;
  ItemType(this._type);

    @override
  String toString() {
    return _type;
  }

static ItemType turtle_helmet = ItemType('minecraft:turtle_helmet');
static ItemType scute = ItemType('minecraft:scute');
static ItemType iron_shovel = ItemType('minecraft:iron_shovel');
static ItemType iron_pickaxe = ItemType('minecraft:iron_pickaxe');
static ItemType iron_axe = ItemType('minecraft:iron_axe');
static ItemType flint_and_steel = ItemType('minecraft:flint_and_steel');
static ItemType apple = ItemType('minecraft:apple');
static ItemType bow = ItemType('minecraft:bow');
static ItemType arrow = ItemType('minecraft:arrow');
static ItemType coal = ItemType('minecraft:coal');
static ItemType charcoal = ItemType('minecraft:charcoal');
static ItemType diamond = ItemType('minecraft:diamond');
static ItemType iron_ingot = ItemType('minecraft:iron_ingot');
static ItemType gold_ingot = ItemType('minecraft:gold_ingot');
static ItemType iron_sword = ItemType('minecraft:iron_sword');
static ItemType wooden_sword = ItemType('minecraft:wooden_sword');
static ItemType wooden_shovel = ItemType('minecraft:wooden_shovel');
static ItemType wooden_pickaxe = ItemType('minecraft:wooden_pickaxe');
static ItemType wooden_axe = ItemType('minecraft:wooden_axe');
static ItemType stone_sword = ItemType('minecraft:stone_sword');
static ItemType stone_shovel = ItemType('minecraft:stone_shovel');
static ItemType stone_pickaxe = ItemType('minecraft:stone_pickaxe');
static ItemType stone_axe = ItemType('minecraft:stone_axe');
static ItemType diamond_sword = ItemType('minecraft:diamond_sword');
static ItemType diamond_shovel = ItemType('minecraft:diamond_shovel');
static ItemType diamond_pickaxe = ItemType('minecraft:diamond_pickaxe');
static ItemType diamond_axe = ItemType('minecraft:diamond_axe');
static ItemType stick = ItemType('minecraft:stick');
static ItemType bowl = ItemType('minecraft:bowl');
static ItemType mushroom_stew = ItemType('minecraft:mushroom_stew');
static ItemType golden_sword = ItemType('minecraft:golden_sword');
static ItemType golden_shovel = ItemType('minecraft:golden_shovel');
static ItemType golden_pickaxe = ItemType('minecraft:golden_pickaxe');
static ItemType golden_axe = ItemType('minecraft:golden_axe');
static ItemType string = ItemType('minecraft:string');
static ItemType feather = ItemType('minecraft:feather');
static ItemType gunpowder = ItemType('minecraft:gunpowder');
static ItemType wooden_hoe = ItemType('minecraft:wooden_hoe');
static ItemType stone_hoe = ItemType('minecraft:stone_hoe');
static ItemType iron_hoe = ItemType('minecraft:iron_hoe');
static ItemType diamond_hoe = ItemType('minecraft:diamond_hoe');
static ItemType golden_hoe = ItemType('minecraft:golden_hoe');
static ItemType wheat_seeds = ItemType('minecraft:wheat_seeds');
static ItemType wheat = ItemType('minecraft:wheat');
static ItemType bread = ItemType('minecraft:bread');
static ItemType leather_helmet = ItemType('minecraft:leather_helmet');
static ItemType leather_chestplate = ItemType('minecraft:leather_chestplate');
static ItemType leather_leggings = ItemType('minecraft:leather_leggings');
static ItemType leather_boots = ItemType('minecraft:leather_boots');
static ItemType chainmail_helmet = ItemType('minecraft:chainmail_helmet');
static ItemType chainmail_chestplate = ItemType('minecraft:chainmail_chestplate');
static ItemType chainmail_leggings = ItemType('minecraft:chainmail_leggings');
static ItemType chainmail_boots = ItemType('minecraft:chainmail_boots');
static ItemType iron_helmet = ItemType('minecraft:iron_helmet');
static ItemType iron_chestplate = ItemType('minecraft:iron_chestplate');
static ItemType iron_leggings = ItemType('minecraft:iron_leggings');
static ItemType iron_boots = ItemType('minecraft:iron_boots');
static ItemType diamond_helmet = ItemType('minecraft:diamond_helmet');
static ItemType diamond_chestplate = ItemType('minecraft:diamond_chestplate');
static ItemType diamond_leggings = ItemType('minecraft:diamond_leggings');
static ItemType diamond_boots = ItemType('minecraft:diamond_boots');
static ItemType golden_helmet = ItemType('minecraft:golden_helmet');
static ItemType golden_chestplate = ItemType('minecraft:golden_chestplate');
static ItemType golden_leggings = ItemType('minecraft:golden_leggings');
static ItemType golden_boots = ItemType('minecraft:golden_boots');
static ItemType flint = ItemType('minecraft:flint');
static ItemType porkchop = ItemType('minecraft:porkchop');
static ItemType cooked_porkchop = ItemType('minecraft:cooked_porkchop');
static ItemType painting = ItemType('minecraft:painting');
static ItemType golden_apple = ItemType('minecraft:golden_apple');
static ItemType enchanted_golden_apple = ItemType('minecraft:enchanted_golden_apple');
static ItemType sign = ItemType('minecraft:sign');
static ItemType bucket = ItemType('minecraft:bucket');
static ItemType water_bucket = ItemType('minecraft:water_bucket');
static ItemType lava_bucket = ItemType('minecraft:lava_bucket');
static ItemType minecart = ItemType('minecraft:minecart');
static ItemType saddle = ItemType('minecraft:saddle');
static ItemType redstone = ItemType('minecraft:redstone');
static ItemType snowball = ItemType('minecraft:snowball');
static ItemType oak_boat = ItemType('minecraft:oak_boat');
static ItemType leather = ItemType('minecraft:leather');
static ItemType milk_bucket = ItemType('minecraft:milk_bucket');
static ItemType pufferfish_bucket = ItemType('minecraft:pufferfish_bucket');
static ItemType salmon_bucket = ItemType('minecraft:salmon_bucket');
static ItemType cod_bucket = ItemType('minecraft:cod_bucket');
static ItemType clownfish_bucket = ItemType('minecraft:clownfish_bucket');
static ItemType brick = ItemType('minecraft:brick');
static ItemType clay_ball = ItemType('minecraft:clay_ball');
static ItemType paper = ItemType('minecraft:paper');
static ItemType book = ItemType('minecraft:book');
static ItemType slime_ball = ItemType('minecraft:slime_ball');
static ItemType chest_minecart = ItemType('minecraft:chest_minecart');
static ItemType furnace_minecart = ItemType('minecraft:furnace_minecart');
static ItemType egg = ItemType('minecraft:egg');
static ItemType compass = ItemType('minecraft:compass');
static ItemType fishing_rod = ItemType('minecraft:fishing_rod');
static ItemType clock = ItemType('minecraft:clock');
static ItemType glowstone_dust = ItemType('minecraft:glowstone_dust');
static ItemType cod = ItemType('minecraft:cod');
static ItemType salmon = ItemType('minecraft:salmon');
static ItemType clownfish = ItemType('minecraft:clownfish');
static ItemType pufferfish = ItemType('minecraft:pufferfish');
static ItemType cooked_cod = ItemType('minecraft:cooked_cod');
static ItemType cooked_salmon = ItemType('minecraft:cooked_salmon');
static ItemType ink_sac = ItemType('minecraft:ink_sac');
static ItemType rose_red = ItemType('minecraft:rose_red');
static ItemType cactus_green = ItemType('minecraft:cactus_green');
static ItemType cocoa_beans = ItemType('minecraft:cocoa_beans');
static ItemType lapis_lazuli = ItemType('minecraft:lapis_lazuli');
static ItemType purple_dye = ItemType('minecraft:purple_dye');
static ItemType cyan_dye = ItemType('minecraft:cyan_dye');
static ItemType light_gray_dye = ItemType('minecraft:light_gray_dye');
static ItemType gray_dye = ItemType('minecraft:gray_dye');
static ItemType pink_dye = ItemType('minecraft:pink_dye');
static ItemType lime_dye = ItemType('minecraft:lime_dye');
static ItemType dandelion_yellow = ItemType('minecraft:dandelion_yellow');
static ItemType light_blue_dye = ItemType('minecraft:light_blue_dye');
static ItemType magenta_dye = ItemType('minecraft:magenta_dye');
static ItemType orange_dye = ItemType('minecraft:orange_dye');
static ItemType bone_meal = ItemType('minecraft:bone_meal');
static ItemType bone = ItemType('minecraft:bone');
static ItemType sugar = ItemType('minecraft:sugar');
static ItemType cookie = ItemType('minecraft:cookie');
static ItemType filled_map = ItemType('minecraft:filled_map');
static ItemType shears = ItemType('minecraft:shears');
static ItemType melon = ItemType('minecraft:melon');
static ItemType dried_kelp = ItemType('minecraft:dried_kelp');
static ItemType pumpkin_seeds = ItemType('minecraft:pumpkin_seeds');
static ItemType melon_seeds = ItemType('minecraft:melon_seeds');
static ItemType beef = ItemType('minecraft:beef');
static ItemType cooked_beef = ItemType('minecraft:cooked_beef');
static ItemType chicken = ItemType('minecraft:chicken');
static ItemType cooked_chicken = ItemType('minecraft:cooked_chicken');
static ItemType rotten_flesh = ItemType('minecraft:rotten_flesh');
static ItemType ender_pearl = ItemType('minecraft:ender_pearl');
static ItemType blaze_rod = ItemType('minecraft:blaze_rod');
static ItemType ghast_tear = ItemType('minecraft:ghast_tear');
static ItemType gold_nugget = ItemType('minecraft:gold_nugget');
static ItemType nether_wart = ItemType('minecraft:nether_wart');
static ItemType potion = ItemType('minecraft:potion');
static ItemType glass_bottle = ItemType('minecraft:glass_bottle');
static ItemType spider_eye = ItemType('minecraft:spider_eye');
static ItemType fermented_spider_eye = ItemType('minecraft:fermented_spider_eye');
static ItemType blaze_powder = ItemType('minecraft:blaze_powder');
static ItemType magma_cream = ItemType('minecraft:magma_cream');
static ItemType brewing_stand = ItemType('minecraft:brewing_stand');
static ItemType cauldron = ItemType('minecraft:cauldron');
static ItemType ender_eye = ItemType('minecraft:ender_eye');
static ItemType speckled_melon = ItemType('minecraft:speckled_melon');
static ItemType bat_spawn_egg = ItemType('minecraft:bat_spawn_egg');
static ItemType blaze_spawn_egg = ItemType('minecraft:blaze_spawn_egg');
static ItemType cave_spider_spawn_egg = ItemType('minecraft:cave_spider_spawn_egg');
static ItemType chicken_spawn_egg = ItemType('minecraft:chicken_spawn_egg');
static ItemType cow_spawn_egg = ItemType('minecraft:cow_spawn_egg');
static ItemType creeper_spawn_egg = ItemType('minecraft:creeper_spawn_egg');
static ItemType dolphin_spawn_egg = ItemType('minecraft:dolphin_spawn_egg');
static ItemType donkey_spawn_egg = ItemType('minecraft:donkey_spawn_egg');
static ItemType drowned_spawn_egg = ItemType('minecraft:drowned_spawn_egg');
static ItemType elder_guardian_spawn_egg = ItemType('minecraft:elder_guardian_spawn_egg');
static ItemType enderman_spawn_egg = ItemType('minecraft:enderman_spawn_egg');
static ItemType endermite_spawn_egg = ItemType('minecraft:endermite_spawn_egg');
static ItemType evocation_illager_spawn_egg = ItemType('minecraft:evocation_illager_spawn_egg');
static ItemType ghast_spawn_egg = ItemType('minecraft:ghast_spawn_egg');
static ItemType guardian_spawn_egg = ItemType('minecraft:guardian_spawn_egg');
static ItemType horse_spawn_egg = ItemType('minecraft:horse_spawn_egg');
static ItemType husk_spawn_egg = ItemType('minecraft:husk_spawn_egg');
static ItemType llama_spawn_egg = ItemType('minecraft:llama_spawn_egg');
static ItemType magma_cube_spawn_egg = ItemType('minecraft:magma_cube_spawn_egg');
static ItemType mooshroom_spawn_egg = ItemType('minecraft:mooshroom_spawn_egg');
static ItemType mule_spawn_egg = ItemType('minecraft:mule_spawn_egg');
static ItemType ocelot_spawn_egg = ItemType('minecraft:ocelot_spawn_egg');
static ItemType parrot_spawn_egg = ItemType('minecraft:parrot_spawn_egg');
static ItemType pig_spawn_egg = ItemType('minecraft:pig_spawn_egg');
static ItemType phantom_spawn_egg = ItemType('minecraft:phantom_spawn_egg');
static ItemType polar_bear_spawn_egg = ItemType('minecraft:polar_bear_spawn_egg');
static ItemType rabbit_spawn_egg = ItemType('minecraft:rabbit_spawn_egg');
static ItemType sheep_spawn_egg = ItemType('minecraft:sheep_spawn_egg');
static ItemType shulker_spawn_egg = ItemType('minecraft:shulker_spawn_egg');
static ItemType silverfish_spawn_egg = ItemType('minecraft:silverfish_spawn_egg');
static ItemType skeleton_spawn_egg = ItemType('minecraft:skeleton_spawn_egg');
static ItemType skeleton_horse_spawn_egg = ItemType('minecraft:skeleton_horse_spawn_egg');
static ItemType slime_spawn_egg = ItemType('minecraft:slime_spawn_egg');
static ItemType spider_spawn_egg = ItemType('minecraft:spider_spawn_egg');
static ItemType squid_spawn_egg = ItemType('minecraft:squid_spawn_egg');
static ItemType stray_spawn_egg = ItemType('minecraft:stray_spawn_egg');
static ItemType turtle_spawn_egg = ItemType('minecraft:turtle_spawn_egg');
static ItemType vex_spawn_egg = ItemType('minecraft:vex_spawn_egg');
static ItemType villager_spawn_egg = ItemType('minecraft:villager_spawn_egg');
static ItemType vindication_illager_spawn_egg = ItemType('minecraft:vindication_illager_spawn_egg');
static ItemType witch_spawn_egg = ItemType('minecraft:witch_spawn_egg');
static ItemType wither_skeleton_spawn_egg = ItemType('minecraft:wither_skeleton_spawn_egg');
static ItemType wolf_spawn_egg = ItemType('minecraft:wolf_spawn_egg');
static ItemType zombie_spawn_egg = ItemType('minecraft:zombie_spawn_egg');
static ItemType zombie_horse_spawn_egg = ItemType('minecraft:zombie_horse_spawn_egg');
static ItemType zombie_pigman_spawn_egg = ItemType('minecraft:zombie_pigman_spawn_egg');
static ItemType zombie_villager_spawn_egg = ItemType('minecraft:zombie_villager_spawn_egg');
static ItemType puffer_fish_spawn_egg = ItemType('minecraft:puffer_fish_spawn_egg');
static ItemType salmon_mob_spawn_egg = ItemType('minecraft:salmon_mob_spawn_egg');
static ItemType cod_mob_spawn_egg = ItemType('minecraft:cod_mob_spawn_egg');
static ItemType tropical_fish_spawn_egg = ItemType('minecraft:tropical_fish_spawn_egg');
static ItemType experience_bottle = ItemType('minecraft:experience_bottle');
static ItemType fire_charge = ItemType('minecraft:fire_charge');
static ItemType writable_book = ItemType('minecraft:writable_book');
static ItemType written_book = ItemType('minecraft:written_book');
static ItemType emerald = ItemType('minecraft:emerald');
static ItemType item_frame = ItemType('minecraft:item_frame');
static ItemType flower_pot = ItemType('minecraft:flower_pot');
static ItemType carrot = ItemType('minecraft:carrot');
static ItemType potato = ItemType('minecraft:potato');
static ItemType baked_potato = ItemType('minecraft:baked_potato');
static ItemType poisonous_potato = ItemType('minecraft:poisonous_potato');
static ItemType map = ItemType('minecraft:map');
static ItemType golden_carrot = ItemType('minecraft:golden_carrot');
static ItemType skeleton_skull = ItemType('minecraft:skeleton_skull');
static ItemType wither_skeleton_skull = ItemType('minecraft:wither_skeleton_skull');
static ItemType zombie_head = ItemType('minecraft:zombie_head');
static ItemType creeper_head = ItemType('minecraft:creeper_head');
static ItemType dragon_head = ItemType('minecraft:dragon_head');
static ItemType carrot_on_a_stick = ItemType('minecraft:carrot_on_a_stick');
static ItemType nether_star = ItemType('minecraft:nether_star');
static ItemType pumpkin_pie = ItemType('minecraft:pumpkin_pie');
static ItemType firework_rocket = ItemType('minecraft:firework_rocket');
static ItemType firework_star = ItemType('minecraft:firework_star');
static ItemType enchanted_book = ItemType('minecraft:enchanted_book');
static ItemType nether_brick = ItemType('minecraft:nether_brick');
static ItemType quartz = ItemType('minecraft:quartz');
static ItemType tnt_minecart = ItemType('minecraft:tnt_minecart');
static ItemType hopper_minecart = ItemType('minecraft:hopper_minecart');
static ItemType prismarine_shard = ItemType('minecraft:prismarine_shard');
static ItemType prismarine_crystals = ItemType('minecraft:prismarine_crystals');
static ItemType rabbit = ItemType('minecraft:rabbit');
static ItemType cooked_rabbit = ItemType('minecraft:cooked_rabbit');
static ItemType rabbit_stew = ItemType('minecraft:rabbit_stew');
static ItemType rabbit_foot = ItemType('minecraft:rabbit_foot');
static ItemType rabbit_hide = ItemType('minecraft:rabbit_hide');
static ItemType armor_stand = ItemType('minecraft:armor_stand');
static ItemType iron_horse_armor = ItemType('minecraft:iron_horse_armor');
static ItemType golden_horse_armor = ItemType('minecraft:golden_horse_armor');
static ItemType diamond_horse_armor = ItemType('minecraft:diamond_horse_armor');
static ItemType lead = ItemType('minecraft:lead');
static ItemType name_tag = ItemType('minecraft:name_tag');
static ItemType command_block_minecart = ItemType('minecraft:command_block_minecart');
static ItemType mutton = ItemType('minecraft:mutton');
static ItemType cooked_mutton = ItemType('minecraft:cooked_mutton');
static ItemType end_crystal = ItemType('minecraft:end_crystal');
static ItemType chorus_fruit = ItemType('minecraft:chorus_fruit');
static ItemType chorus_fruit_popped = ItemType('minecraft:chorus_fruit_popped');
static ItemType beetroot = ItemType('minecraft:beetroot');
static ItemType beetroot_seeds = ItemType('minecraft:beetroot_seeds');
static ItemType beetroot_soup = ItemType('minecraft:beetroot_soup');
static ItemType dragon_breath = ItemType('minecraft:dragon_breath');
static ItemType splash_potion = ItemType('minecraft:splash_potion');
static ItemType spectral_arrow = ItemType('minecraft:spectral_arrow');
static ItemType tipped_arrow = ItemType('minecraft:tipped_arrow');
static ItemType lingering_potion = ItemType('minecraft:lingering_potion');
static ItemType shield = ItemType('minecraft:shield');
static ItemType elytra = ItemType('minecraft:elytra');
static ItemType spruce_boat = ItemType('minecraft:spruce_boat');
static ItemType birch_boat = ItemType('minecraft:birch_boat');
static ItemType jungle_boat = ItemType('minecraft:jungle_boat');
static ItemType acacia_boat = ItemType('minecraft:acacia_boat');
static ItemType dark_oak_boat = ItemType('minecraft:dark_oak_boat');
static ItemType totem_of_undying = ItemType('minecraft:totem_of_undying');
static ItemType shulker_shell = ItemType('minecraft:shulker_shell');
static ItemType iron_nugget = ItemType('minecraft:iron_nugget');
static ItemType knowledge_book = ItemType('minecraft:knowledge_book');
static ItemType debug_stick = ItemType('minecraft:debug_stick');
static ItemType music_disc_13 = ItemType('minecraft:music_disc_13');
static ItemType music_disc_cat = ItemType('minecraft:music_disc_cat');
static ItemType music_disc_blocks = ItemType('minecraft:music_disc_blocks');
static ItemType music_disc_chirp = ItemType('minecraft:music_disc_chirp');
static ItemType music_disc_far = ItemType('minecraft:music_disc_far');
static ItemType music_disc_mall = ItemType('minecraft:music_disc_mall');
static ItemType music_disc_mellohi = ItemType('minecraft:music_disc_mellohi');
static ItemType music_disc_stal = ItemType('minecraft:music_disc_stal');
static ItemType music_disc_strad = ItemType('minecraft:music_disc_strad');
static ItemType music_disc_ward = ItemType('minecraft:music_disc_ward');
static ItemType music_disc_11 = ItemType('minecraft:music_disc_11');
static ItemType music_disc_wait = ItemType('minecraft:music_disc_wait');
static ItemType trident = ItemType('minecraft:trident');
static ItemType phantom_membrane = ItemType('minecraft:phantom_membrane');
static ItemType nautilus_shell = ItemType('minecraft:nautilus_shell');
static ItemType heart_of_the_sea = ItemType('minecraft:heart_of_the_sea');

}